-- libsm64 BLUA conversions, shoved into their own lua so that it doesn't screw with the main code
-- while n64 mario is non-reusable, you are very much free to use this BLUA libsm64 in your own mods, as I feel it'll be useful to some

--freeslots
freeslot("sfx_sgwkc", "sfx_sgmwk", "sfx_sgiwk", "sfx_sgkfl", "sfx_rkwkv", "sfx_sglwk")



--locals
local SOUND_ACTION_METAL_BONK = sfx_sgmwk;
local SOUND_ACTION_BONK = sfx_sgwkc;
local angleFrac = 72817;

rawset(_G, "tallest_line", 0);

local function mobj2DCheck(mobj)
	local var = ((mobj.flags2 & MF2_TWOD) or twodlevel)
	return var
end

addHook("MapLoad", do -- find the absolute tallest line on the map
	for l in lines.iterate
	do
		if l.backsector
			if l.backsector.ceilingheight > tallest_line
				if (l.backsector.ceilingpic == "F_SKY1")
					tallest_line = l.backsector.ceilingheight;
				end
			end
		end
		
		if l.frontsector
			if l.frontsector.ceilingheight > tallest_line
				if (l.frontsector.ceilingpic == "F_SKY1")
					tallest_line = l.frontsector.ceilingheight;
				end
			end
		end
	end
	
	//print(tallest_line/FRACUNIT);
end)

/**
 * Helper function for atan2s. Does a look up of the arctangent of y/x assuming
 * the resulting angle is in range [0, 0x2000] (1/8 of a circle).
 */
local function atan2_lookup(y, x)
    local ret;
    local finey = y*100; -- makes something like 30/40 = 75 (0.75 in reality)

    if (x == 0)
        ret = 0;
    else
        local fArctan = (((finey / x) * 1024 + 50)/100);
        ret = (fArctan*8); -- not putting in a giant lookup table when this is easier
    end

    return ret;
end

local function fracToAngle(fut) -- convert a fracunit/fixed_t to an angle_t, going to assume the resulting s16 in atan2s is essentially a fixed_t
    if fut == nil then return 0 end;
    
    return (((fut*100)/angleFrac) * ANG1);
end

// Returns the height of the sector ceiling at (x, y)
local function P_GetSectorCeilingZAt(sector, x, y)
	return ((sector.c_slope) and P_GetZAt(sector.c_slope, x, y) or sector.ceilingheight);
end


local function lineCollisions(p, debug)
	local nocollide = false;
	local wall = ((p.prevwall) and lines[p.prevwall] or lines[p.lastlinehit]);
	local wallside;
	local nomidtex = false;
	local defaulted = false;
	local hitsector = nil;
	
	//print("\x84".."BEGIN WALL COLLIDE")
	
	if (wall)
		/*if (not wall.backsector)
			print("not dualsided");
			nocollide = true;
		end*/
		wallside = sides[wall.sidenum[P_PointOnLineSide(p.mo.x,p.mo.y,wall)]];
		
		if (wallside)
			if (not wallside.midtexture)
				nomidtex = true;
			end
		end
		
		hitsector = wall.backsector;	
			
		if P_PointOnLineSide(p.mo.x,p.mo.y,wall)
			hitsector = wall.frontsector;
		end
		
		//print(P_PointOnLineSide(p.mo.x,p.mo.y,wall) and "frontsector" or "backsector");
		
		if ((hitsector == nil) or (not hitsector.valid))
			//print("\x82".."sector doesn't exist");
			//print("defaulting to frontsector...");
			if (wall.frontsector)
				hitsector = wall.frontsector; // panic swap to frontsector
				defaulted = true;
			else
				//print("\x85".."frontsector doesn't exist");
				nocollide = true;
			end
		end
		
		local skywall;
			
		if (hitsector)
			//print(hitsector.ceilingheight/FRACUNIT);
			//print(p.mo.z/FRACUNIT);
			//print(hitsector.ceilingpic);
			
			skywall = (hitsector.ceilingpic:find("F_SKY"));
		end
		
		
		
		if (defaulted)
			if (nomidtex and skywall) -- no middle texture exists, let's assume this wall is invisible
				--imperfect from the start and anything that has an "extending out" texture will really mess with this
				
				//print("\x85".."can't find valid texture");
				nocollide = true;
			end
		end
			
		if ((not nocollide) and (hitsector.ceilingheight < p.mo.z) and (skywall))
			//print("\x85".."thok barrier");
			nocollide = true;
		end
	else
		//print("\x85".."no collideline");
		nocollide = true;
	end
	
	//print("__________________");

	if (nocollide)
		p.rk_skyjumper = true;
	end
	
    if ((lines[p.lastlinehit] ~= nil) and ( ((p.wallmem) and (p.airHit)) or debug))
		if (p.rk_skyjumper) then return nil; end -- no sir
		return lines[p.lastlinehit];
    else
        return nil; -- paranoia
    end
end

--rawsets ("global" functions)

rawset(_G, "MARIO_ANIM_START_WALLKICK", 204) -- a surprise tool that'll help us later :^)

--action rawsets (imminent SIGSEGVs)
rawset(_G, "ACT_AIR_HIT_WALL", 167)
rawset(_G, "ACT_WALL_KICK_AIR", 134)

/**
 fork of the orginal atan2s code to work with SRB2's angle_t system
 original text:
 * Compute the angle from (0, 0) to (x, y) as a s16. Given that terrain is in
 * the xz-plane, this is commonly called with (z, x) to get a yaw angle.
 */
 --between you and me: this was going to be a local at some point LMAO
rawset(_G, "atan2ang", function(y, x)
    local ret; -- originally was a UINT16

    --paranoia
    local ly = y/FRACUNIT; 
    local lx = x/FRACUNIT;

    local hexC = 49152; -- 0xC000 as an integer, since I can't cheat with bitshifts

    if (lx >= 0)
        if (ly >= 0)
            if (ly >= lx)
                ret = atan2_lookup(lx, ly);
            else
                ret = (1<<14) - atan2_lookup(ly, lx);
            end
        else
            ly = -ly;
            if (y < x)
                ret = (1<<14) + atan2_lookup(ly, lx);
            else
                ret = (1<<15) - atan2_lookup(lx, ly);
            end
        end
    else
        lx = -lx;
        if (y < 0)
            ly = -ly;
            if (ly >= lx)
                ret = (1<<15) + atan2_lookup(lx, ly);
            else
                ret = (1<<15) - atan2_lookup(ly, lx);
            end
        else
            if (ly < lx)
                ret = hexC + atan2_lookup(ly, lx);
            else
                ret = -atan2_lookup(lx, ly);
            end
        end
    end

    local retang = fracToAngle(ret);
    
    return retang;
end)

rawset(_G, "l64_mario_bonk_reflection", function(mo, negateSpeed, bing, metal, rebound) 
	-- "m" here can just be our player's mobj, and negateSpeed is a boolean. 
    -- "bing" does the "wall impact sounds" otherwise only needed by n64 mario
    local p = mo.player
	
	local mWall = (mo.player and (lineCollisions(p)) or nil);
	
	
	
	if (p.justbonked) then return end

    if (mWall ~= nil)
		
		local ang360 = 4294967295; // somehow this is NEGATIVE
		local ang180 = 2147483648;
		local hundredthAng = 119305;
        local realWall = mWall; -- :^)
		local actualAngle;
		local lineangle;
		local linepoint;
		local lineangdiff;
		local linereflect;
		local wallAngle;
		//print("mwall exists");

        -- hack together x and z normals for linedefs
		//
        local pols = (P_PointOnLineSide(p.mo.x,p.mo.y,realWall.v1.x,realWall.v1.y,realWall.v2.x,realWall.v2.y))
		local ls = ((pols) and 1 or -1);

        local normalZ = R_PointToDist2(realWall.v2.x,realWall.v2.y,realWall.v1.x,realWall.v1.y);
        local normalX = R_PointToDist2(realWall.v2.x,0,realWall.v1.x,0);
		
		local pointangle = ( R_PointToAngle2(realWall.v2.x,realWall.v2.y,realWall.v1.x,realWall.v1.y) + (ANGLE_90*ls) );
		local pointangdiff = (pointangle - p.mo.angle);
		local negative = false;
		
		if (pointangdiff < 0)
			negative = true;
		end
		
		if (abs(pointangdiff) < 45)
			pointangdiff = (45 * ((negative) and -1 or 1) );
		end
		
		negative = nil;
		
		local rls = ls;
		
		local wallpoint = R_PointToAngle2(realWall.v2.x,realWall.v2.y,realWall.v1.x,realWall.v1.y) - (ANGLE_90*ls);
		
		wallpoint = $/ANG1;
		
		wallpoint = ((wallpoint >= 0) and $ or (180 + ( $ * (-1) )) );
		
		if (wallpoint >= 180)
			rls = $ * (-1);
		end
		
		local reflectangle = (R_PointToAngle2(realWall.v2.x,realWall.v2.y,realWall.v1.x,realWall.v1.y) - (ANGLE_90*ls) + (pointangdiff));
		
		if (mobj2DCheck(p.mo))
			reflectangle = InvAngle(p.mo.angle);
			p.kickmul2d = ((p.mo.angle) and 1 or -1)
		end
		
		rls = nil;

        wallAngle = atan2ang(normalZ, normalX);
		
		if (mo.angle < 0)
			actualAngle = (ang360 + mo.angle);
		else
			actualAngle = mo.angle;
		end
		
		ang360 = nil;
		
        local wallDiff = ((mo.angle) + wallAngle);

        normalX = nil;
        normalZ = nil;
		
		local reftrim;
		
		reftrim = ((wallAngle/hundredthAng) + 18000) + (wallDiff/hundredthAng); // fine value
		
		//p.mo.angle = InvAngle(reflectangle);
		//p.drawangle = InvAngle(reflectangle);
		
		p.kickang = reflectangle;
		p.kickang_2d = InvAngle(p.mo.angle);
		
		p.wallangmem = R_PointToAngle2(realWall.v2.x,realWall.v2.y,realWall.v1.x,realWall.v1.y) + (ANGLE_90*ls);
		
		if (mobj2DCheck(p.mo))
			p.mo.momx = $ * -1;
			p.mo.momy = $ * -1;
		else
			P_InstaThrust(mo, reflectangle, ((rebound) and ((p.speedmem) and (p.speedmem/3) or (p.speed/3)) or 5) );
		end
        wallDiff = nil;

        if (p and bing)
            S_StartSound(mo, ((metal) and SOUND_ACTION_METAL_BONK or SOUND_ACTION_BONK));
			//S_StartSound(p.mo, sfx_sgkfl); // remove if you plan to use this standalone
        end
		
		
    elseif (bing)
        S_StartSound(mo, sfx_sgiwk); //play_sound(SOUND_ACTION_HIT, m->marioObj->header.gfx.cameraToObject); -- YOU'RE TELLING ME THERE'S A CAMERA OBJECT
    end

    if (negateSpeed)
        local mospeed = R_PointToDist2(mo.x, mo.y, mo.x+(mo.momx), mo.y+(mo.momy));
		//print("negate");
        P_InstaThrust(mo, mo.angle -mospeed);
    else
        //mo.angle = ($ + fracToAngle(1<<15));
    end
	p.justbonked = true;
end)

local function wallKickThinker(p, bing, nerf)
	if (not p.wallKickReady) then return; end
	if (p.l64_justkicked2) then return; end
	
	if ((p.mo.lib64_actionTimer2 + 1) <= 10)
        if ((p.l64_jumpDownTime and (p.l64_jumpDownTime <= 2)) and (not p.lib64_wallkicked) and (not p.justKicked))
            p.mo.momz = FixedMul(52*FRACUNIT, p.mo.scale)*P_MobjFlip(p.mo); --52.0f
			p.mo.momz = ($/3);
            //p.mo.angle = ($ + fracToAngle(1<<15));
			//p.mo.angle = InvAngle(p.mo.angle);
			//P_BounceMove(p.mo); // please properly reflect the player
			p.mo.angle = ((mobj2DCheck(p.mo)) and p.kickang_2d or p.kickang);
			local kickspeed = max((18*p.mo.scale), ((p.kickspeed) and abs(p.kickspeed/nerf) or abs(p.speed/nerf)));
			if (not (p.pflags & PF_STARTJUMP))
				p.pflags = $|PF_STARTJUMP;
			end
			
			
			p.kickspeedmem = kickspeed; -- store this to prevent speedkill bug
			p.kicklinger = TICRATE/4;
			
			if (mobj2DCheck(p.mo))
				//P_InstaThrust(p.mo, p.kickang_2d, kickspeed );
			else
				P_InstaThrust(p.mo, p.mo.angle, kickspeed );
			end
			//print(kickspeed/p.mo.scale);
			
			kickspeed = nil;
			
			p.justKicked = 6;
			p.l64_justkicked2 = true;
			
            p.lib64_action = ACT_WALL_KICK_AIR;
			
			StopN64MarioVoice(p)
			local nothok = (not (p.pflags & PF_THOKKED));
			
			if (bing) then S_StartSound(p.mo, ((nothok or p.rk_yeehaw) and sfx_rkwkv or sfx_sglwk) ); end
			if (not nothok) then p.rk_yeehaw = true; end
			p.rk_poundprevent = (TICRATE/5); -- 1/5th a second of GP prevention
			
			nothok = nil;
			
			p.lib64_wallkicked = true;
			p.nokickrepeat = true;
			p.mo.lib64_actionTimer2 = 11;
            return;
        end
		
		//print(p.mo.lib64_actionTimer);
	end
end

rawset(_G, "l64A_AirHitWall", function(p, avoidUB, bing, nerf) --thinker action 167

	//')' expected (to close '(' at line 145) near 'if'
    P_PlayerFlagBurst(p, false); -- originally a general "object drop" code

    local fracVel = R_PointToDist2(p.mo.x, p.mo.y, p.mo.x+(p.mo.momx), p.mo.y+(p.mo.momy));
	
	local fv = ((p.speedmem) and p.speedmem or fracVel);
    local forwardVel = (fracVel/p.mo.scale)*3;
	
	if (p.mo.lib64_actionTimer == nil) 
		p.mo.lib64_actionTimer = 0;
	end
	
	if (not p.lib64_wallkicked)
		p.mo.lib64_actionTimer = ($+1);
	end
	
	//print((p.lib64_wallkicked) and "wallkick" or "no kick");
	//print(p.mo.lib64_actionTimer);
	
	if ((not p.lib64_wallkicked) and ((p.mo.lib64_actionTimer) <= 4))
		if (forwardVel >= 38)
			p.mo.lib64_wallKickTimer = 5;
			if (p.mo.momz > 0) then p.mo.momz = 0; end
			//print("zstop");
			
			p.justKicked = 6; // still do justkicked to reset everything 
		else
			p.mo.lib64_wallKickTimer = 5;

			if (p.mo.momz > 0) then p.mo.momz = 0; end

			if (forwardVel > 8) then P_InstaThrust(p.mo, p.mo.angle, -(4*p.mo.scale)); end
			//print("no action");
			
			p.l64_hitWall = false;
			p.airHit = false;

			return false;
		end
	end

    if (avoidUB) then return; end

    --set a generic value so that you don't have to jury-rig the function to work with whatever you make
    p.lib64_animation = MARIO_ANIM_START_WALLKICK; 

    //! Missing return statement. The returned value is the result of the call
    // to set_mario_animation. In practice, this value is nonzero.
    // This results in this action "cancelling" into itself. It is supposed to
    // execute on two frames, but instead it executes twice on the same frame.
    // This results in firsties only being possible for a single frame, instead
    // of two.
end)

rawset(_G, "l64A_WallKickAir", function(p, jumpSound)
    if (p.cmd.buttons & BT_CUSTOM1)
        p.lib64_action = ACT_DIVE;
        return;
    end

    if (p.cmd.buttons & BT_USE)
        p.lib64_action = ACT_GROUND_POUND;
        return;
    end

    if (jumpSound) then S_StartSound(mo, jumpSound); end
    return false;
end)

rawset(_G, "l64_AirStepHitWall", function(mo, bingbing, metal)
	local p = mo.player;
	
	if (p and p.speedmem and (p.speedmem < 17*p.mo.scale)) then return; end
	
	if (mo.player) then mo.state = S_PLAY_FALL; end
	
	local fracVel = R_PointToDist2(mo.x, mo.y, mo.x+(mo.momx), mo.y+(mo.momy));
	local fv = ((p.velMem) and p.velMem or fracVel);
	
    local forwardVel = ((fv)/FRACUNIT);
	
	//print(forwardVel);

    local mWall = (mo.player and (lineCollisions(p)) or nil);
	
	//local hispeed = ((mo.player and p.l64_stronghit or (forwardVel > 16)) and true or false) -- CONDITIONAL STACKING YEEEHAWW

    if (p.rky_fastHit)
        l64_mario_bonk_reflection(mo, false, bingbing, metal, false);
		
		if (not p.rk_skyjumper)
			p.kicklinger = 0;
			p.mo.state = S_PLAY_WPCH;
			p.drawangle = ((p.wallangmem) and p.wallangmem or $);
			p.mo.momz = ($ - max(1, (p.mo.momz/8)) )
			p.rk_poundprevent = (TICRATE/2); -- half a second of GP prevention
			p.wallKickReady = true;
		end
        
		if (not mo.autosnap)
			mo.angle = ($ + fracToAngle(1<<15));
			mo.autosnap = true;
		end

        if ((mWall ~= nil) and mWall.valid)
            p.lib64_action = ACT_AIR_HIT_WALL;
        elseif (not p.lib64_wallkicked)
            //if (mo.momz > 0) then mo.momz = 0; end STOP
            

            if (forwardVel < 38)
                if (forwardVel > 8) then P_InstaThrust(mo, mo.angle, -(4*mo.scale)); end

                return;
            end
        end
		if (mo.player) then p.l64_stronghit = false; end
    else
        P_InstaThrust(mo, mo.angle, 0);
    end
	if (mo.player) p.l64_hitWall = false; end
end)

rawset(_G, "l64_ActionThinker", function(p, wallKickSound)
    if (p.lib64_loopAct == nil) then p.lib64_loopAct = true; end

    if (p.lib64_loopAct == false) then p.lib64_loopAct = nil; p.lib64_action = 0; return; end
	
	if (P_PlayerInPain(p) or p.rkyBurned) then p.lib64_action = 0; return; end -- don't do SHIT if you're hurt

    -- yep
	if ((p.lib64_action == ACT_AIR_HIT_WALL) and (P_IsObjectOnGround(p.mo)))
		p.lib64_action = 0;
	end
	
	if (P_IsObjectOnGround(p.mo))
		p.kickspeed = 0;
		p.mo.lib64_actionTimer2 = 0;
		p.wallKickReady = false;
		p.rk_yeehaw = false;
		p.rk_skyjumper = false;
	end
	
	//print(p.lib64_action);
	
	-- start wall kick hacks
	if (p.cmd.buttons & BT_JUMP)
		if (p.l64_jumpDownTime)
			p.l64_jumpDownTime = $ + 1;
		else
			p.l64_jumpDownTime = 1;
		end
	else
		p.l64_jumpDownTime = 0;
	end
	
	if (p.wallKickReady)
		p.mo.lib64_actionTimer2 = ($ + 1);
		p.drawangle = ((p.wallangmem) and p.wallangmem or $);
		
		if (p.mo.lib64_actionTimer2 > 10)
			// remove the sound function if you plan to use this standalone
			if ((not p.lib64_wallkicked) and (not P_IsObjectOnGround(p.mo)) and (p.mo.state ~= S_PLAY_WKCK)) then
			StopN64MarioVoice(p)
			S_StartSound(p.mo, sfx_sgkfl); 
			end
			p.mo.lib64_actionTimer2 = 0;
			p.wallangmem = nil;
			p.wallKickReady = false;
		end
	else
		p.mo.lib64_actionTimer2 = 0;
	end
	
	wallKickThinker(p, true, ((p.pflags & PF_THOKKED) and 1 or 2));
	
	//print(p.mo.lib64_actionTimer2);
	
	if (p.justKicked)
		if (p.justKicked == 1)
			p.rky_prehit = false;
			p.kickfall = true;
			p.wallmem = 0;
			p.lib64_action = 0;
			p.justbonked = nil;
			p.mo.lib64_actionTimer = 0;
			p.l64_hitWall = false;
			p.airHit = false;
			p.lib64_wallkicked = false;
		end
		
		p.justKicked = $ - 1;
	end
	
	if (p.kicklinger and (p.mo and p.mo.valid))
		local lingerang = (mobj2DCheck(p.mo) and p.kickang_2d or p.mo.angle);
		
		if (not mobj2DCheck(p.mo))
			p.mo.momx = FixedMul(p.kickspeedmem, cos(lingerang));
			p.mo.momy = FixedMul(p.kickspeedmem, sin(lingerang));
		else
			p.mo.momx = p.kickspeedmem * ((p.kickmul2d) and p.kickmul2d or 1); -- only other angle in 2D mode is 180 :^)
			p.drawangle = R_PointToAngle2(0,0,p.mo.momx,p.mo.momy);
			p.mo.momy = 0;
		end
		
		p.kicklinger = $ - 1;
	end
	-- end wall kick hacks
	
	-- are you ready to vomit? because this spaghetti is undercooked
    if (p.lib64_action == ACT_AIR_HIT_WALL)
		p.lib64_loopAct = l64A_AirHitWall(p, nil, true, ((p.pflags & PF_THOKKED) and 1 or 2));
    elseif (p.lib64_action == ACT_WALL_KICK_AIR)
        p.lib64_loopAct = l64A_WallKickAir(p, wallKickSound);
    end
end)