// LUA_RKYINT

// Sets up N64 Mario, who has gotten hilariously big.
// Also sets up 1-up thinkers and necessary functions.
-- Credits: 
-- Rueven - Director, rigging, materials, and main spriter/animator.
-- Cherry - Co-director, programmer.
-- Water Vapor - Co-director, quality control. Sprited Mario's ending constellation.
-- Dokotroopi - Made the MARIO font for the CSS.
-- Cookie - Modeler.
-- Other Chen - Programmed the base for Mario's crouch.
-- Golden Shine - Made the player collision example code, which served as a base for bumper and booster collision.
-- Lach (for Junio Sonic) - Ported the spindash dust code and programmed the base for crouch and Jump Special checking.
-- SMS Alfredo (for the MK64 Cast) - Made the base system for camera angle checking.

-- daypeecone (for Church of Kondo) - Remastered the music tracks from Super Mario 64 used in this mod.
-- SM64 Decomp (https://github.com/n64decomp/sm64) - Gave us readily-avaiable SM64 code that was (mostly) easy to convert to BLUA
-- libsm64 (https://github.com/libsm64/libsm64) - Gave us readily-avaiable SM64 code that was (mostly) easy to convert to BLUA
-- Others we've likely forgotten to mention - Help and support for the whole year (and counting!) we've spent on this dude.

-- Audio is from Super Mario 64, Super Mario Sunshine, Mario Kart 64, Mario Party 3, 
-- the Super Mario Advance games, and Paper Mario: the Thousand Year Door.


-- tons of freeslots, SGCR has a ton more
freeslot("sfx_64hrg", "sfx_641sp", "sfx_64con", "sfx_64ste", 
		 "sfx_64sts", "sfx_64dmg", "sfx_64brbc", "sfx_64brn", 
		 "sfx_64alm", "sfx_64elec", "sfx_64cam", "sfx_rkfal1", 
		 "sfx_rkdiee","sfx_rkdwn", "sfx_64bruw", "SPR_RSPK", "SPR_RSSP", 
		 "S_RKYSPRKL", "S_RKSTRSP1", "S_RKSTRSP2", "S_RKSTRSP3", 
		 "MT_RKYPOOFRING");

-- coin
freeslot("SPR_RKCN", "S_RKYCOIN");

-- junk for controlstyle
local CS_LEGACY = 0
local CS_LMAOGALOG = 1
local CS_STANDARD = 2
local CS_SIMPLE = 3 -- 3 :^)

-- for camera sfx
local cv_directionchar1 = CV_FindVar("directionchar");

sfxinfo[sfx_641sp].flags = $|SF_X4AWAYSOUND
sfxinfo[sfx_64brbc].flags = $|SF_X2AWAYSOUND -- butt bounce is louder
sfxinfo[sfx_64cam].flags = $|SF_TOTALLYSINGLE -- no cascading camera sounds, please

states[S_RKYSPRKL] = {SPR_RSPK, FF_ANIMATE|FF_FULLBRIGHT|A, 6, nil, 5, 2, S_NULL}

states[S_RKSTRSP1] = {SPR_RSSP, FF_FULLBRIGHT|A, 7, nil, 0, 0, S_RKSTRSP2}
states[S_RKSTRSP2] = {SPR_RSSP, FF_FULLBRIGHT|B, 4, nil, 0, 0, S_RKSTRSP3}
states[S_RKSTRSP3] = {SPR_RSSP, FF_FULLBRIGHT|C, 3, nil, 0, 0, S_NULL}

states[S_RKYCOIN] = {SPR_RKCN, FF_ANIMATE|FF_GLOBALANIM, -1, nil, 23, 1, S_RKYCOIN} // S_RING

rawset(_G, "rkysuperman", CV_RegisterVar({
  name = "rkysuperman",
  defaultvalue = "Off",
  flags = CV_NETVAR,
  PossibleValue = CV_OnOff,
}))


-- originally a macro in the source code, doesn't seem to be exposed to lua from what I've checked
rawset(_G, "P_ControlStyle", function(player) 
    return (((player.pflags & PF_ANALOGMODE) and CS_LMAOGALOG or 0) | ((player.pflags & PF_DIRECTIONCHAR) and CS_STANDARD or 0));
end)

rawset(_G, "reverse_number", function(b)
   b = (b & 0xF0) >> 4 | (b & 0x0F) << 4;
   b = (b & 0xCC) >> 2 | (b & 0x33) << 2;
   b = (b & 0xAA) >> 1 | (b & 0x55) << 1;
   return b;
end)

rawset(_G, "printBinary", function(num)
	local bin = 0;
	if (num == nil)
	then
		print(bin);
		return;
	end
	
	local mun = reverse_number(num);
	
	while(mun ~= 0)
	do
		if (mun & 1)
		then
			bin = ($ * 10) + 1;
		else
			bin = $ * 10;
		end
		mun = $ >> 1;
	end
	
	print(bin);
end)

print("binary test");
printBinary(237);

rawset(_G, "N64MarioPresent", function()
	if (multiplayer)
	then
		return false;
	end

	
	for p in players.iterate do
		if (p.mo and p.mo.valid)
			if ((p.mo.skin == "sgimario") and (not rk_dontusehealth)) then return true; end
		end
	end
	
	if (consoleplayer and consoleplayer.valid)
	and (skins[consoleplayer.skin].name == "sgimario")
	then
		return true;
	end
	
	return false;
end)

rawset(_G, "N64MarioLocal", function()
	local result = false;
	
	if (displayplayer and displayplayer.valid and displayplayer.mo and displayplayer.mo.valid)
		if (((displayplayer.mo.skin == "sgimario") and (not rk_dontusehealth))
		or (displayplayer.mo.skin == "mario")
		or (displayplayer.mo.skin == "luigi"))
			result = true; 
		end
	end
	
	if (secondarydisplayplayer 
	and secondarydisplayplayer.valid 
	and secondarydisplayplayer.mo 
	and secondarydisplayplayer.mo.valid)
		if (((secondarydisplayplayer.mo.skin == "sgimario") and (not rk_dontusehealth))
		or (secondarydisplayplayer.mo.skin == "mario")
		or (secondarydisplayplayer.mo.skin == "luigi"))
			result = true; 
		end
	end
	
	return result;
end)

-- cherry: I've been playing SRB2 with a switch online N64 controller rencently
-- playing N64 mario *without* these goofy sounds felt...wrong
rawset(_G, "N64M_CameraSFX", function(mo)
	if (mo.rky_camsfx == nil)
	then
		mo.rky_camsfx = 0;
	end
	
	if (not (mo.player and mo.player.valid)) then return; end
	if (not (P_ControlStyle(mo.player) == CS_SIMPLE)) then return; end
	
	local newsfx = cv_directionchar1.value - 1;
	
	if (newsfx) and (mo.rky_camsfx == 0)
	then
		S_StartSound(nil, sfx_64cam, mo.player);
	end
	
	mo.rky_camsfx = newsfx;
end)

// ported from kart
rawset(_G, "K_FlipFromObject", function(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP);
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP);

	if (mo.eflags & MFE_VERTICALFLIP)
		mo.z = ($ + master.height - FixedMul(master.scale, mo.height));
	end
end)

local function one_up_loop_in_air(mo)
    if (mo.timealive and (mo.timealive < 5))
        mo.momz = (40*mo.scale)/4;
    else
        mo.oAngleVelPitch = -0x1000;
        mo.oMoveAnglePitch = ((mo.oMoveAnglePitch ~= nil) and ($ + mo.oAngleVelPitch) or mo.oAngleVelPitch);
        mo.momz = (FixedMul(cos((mo.oMoveAnglePitch*FRACUNIT)), (30 + 2)*FRACUNIT)/4);
        mo.oForwardVel = FixedMul(-sin((mo.oMoveAnglePitch*FRACUNIT)), 30*FRACUNIT)/4;
		
		P_InstaThrust(mo, mo.angle, mo.oForwardVel);
    end
end

// hook for flying 1-ups
addHook("MobjThinker", function(mo)
	if (mo.sprite ~= SPR_RKEL)
		return;
	end
	
	mo.timealive = ((mo.timealive ~= nil) and ($ + 1) or 0);
	
	if (mo.timealive ~= (TICRATE*2)+2)
		one_up_loop_in_air(mo)
		
		if (mo.spawnanim and (leveltime % 2 == 0))
			local sparklefx = P_SpawnMobj(mo.x+(P_RandomRange(0,4)*FRACUNIT/4), mo.y+(P_RandomRange(0,4)*FRACUNIT/4), mo.z+(P_RandomRange(0,4)*FRACUNIT/4), MT_THOK);
			sparklefx.tics = -1;
			sparklefx.fuse = -1;
			sparklefx.scale = 3*mo.scale/2;
			sparklefx.frame = A;
			sparklefx.state = S_RKYSPRKL;
			sparklefx.renderflags = $|RF_FULLBRIGHT|RF_NOCOLORMAPS
		end
	else
		mo.spawnanim = 0;
	end
	
	if (mo.tracer and (not mo.spawnanim))
		if (mo.timealive > TICRATE/8)
			P_Attract(mo, mo.tracer, true, true);
			
		end
		
		if (mo.tracerdist and (mo.tracerdist <= (mo.radius + (mo.tracer.radius/2)) ))
			if (mo.tracer.player)
				if ((ultimatemode) and (not mo.tracer.player.exiting)) // green demons :^)
					P_DamageMobj(mo.tracer, mo, mo, 1, DMG_FIRE);
					P_RemoveMobj(mo);
					return;
				end

				P_GiveCoopLives(mo.tracer.player, 1, false);
				
				S_StartSound(nil, sfx_641up, p);
			end
			P_RemoveMobj(mo);
			
			return;
		end
	end
end, MT_THOK)

// fancy N64 coins

local function P_RingsTo64Coins()
	local supramayro = N64MarioPresent();
	if (supramayro) 
	then
		mobjinfo[MT_RING].spawnstate = S_RKYCOIN
		mobjinfo[MT_RING].deathsound = sfx_64con
	else
		mobjinfo[MT_RING].spawnstate = S_RING
		mobjinfo[MT_RING].deathsound = sfx_itemup
	end
end

addHook("MapChange", P_RingsTo64Coins);