-- SPINNING HEART CODE
-- very much a BLUA version of recovery_heart.inc.c from the SM64 decomp

freeslot("SPR_RKHT", "SPR_RKRG", "S_RKYRHRT", "MT_RECOVERYHEART", "S_SPRRNG1", "S_SPRRNG2", "S_SPRRNG3", "S_SPRRNG4", "sfx_64hrt", "sfx_10rng")

states[S_RKYRHRT] = {SPR_RKHT, A|FF_PAPERSPRITE|FF_TRANS30, -1, nil, 0, 0, S_RKYRHRT}

-- in multiplayer, spinning hearts become Super Rings for non-mario players
states[S_SPRRNG1] = {SPR_RKRG, A|FF_PAPERSPRITE|FF_FULLBRIGHT, -1, nil, 0, 0, S_SPRRNG1}
states[S_SPRRNG2] = {SPR_RKRG, A|FF_PAPERSPRITE|FF_FULLBRIGHT, 20, nil, 0, 0, S_SPRRNG3}
states[S_SPRRNG3] = {SPR_RKRG, A|FF_PAPERSPRITE|FF_FULLBRIGHT|FF_TRANS30, 4, nil, 0, 0, S_SPRRNG4}
states[S_SPRRNG3] = {SPR_RKRG, A|FF_PAPERSPRITE|FF_FULLBRIGHT|FF_TRANS60, 3, nil, 0, 0, S_INVISIBLE}

mobjinfo[MT_RECOVERYHEART] = {
	doomednum = -1,
	spawnstate = S_RKYRHRT,
	spawnhealth = 1000,
	radius = 25*FRACUNIT,
	height = 25*FRACUNIT,
	flags = MF_NOGRAVITY
}


local function RK_HeartCheck(mo, p)
	for i = 1, #mo.gotTenRings
	do
		if (mo.gotTenRings[i] == p)
			return false;
		end
	end
	
	return true;
end

local function localMarioCheck()
	local wahoo = false;
	
	if (not (displayplayer and displayplayer.valid)) then return; end
	
	if (displayplayer.mo 
	and displayplayer.mo.valid 
	and ((displayplayer.mo.skin == "sgimario") or (displayplayer.mo.skin == "mario") or (displayplayer.mo.skin == "luigi"))
	and (not displayplayer.rk_dontusehealth))
		wahoo = true;
	end
	
	if (secondarydisplayplayer 
	and secondarydisplayplayer.valid 
	and secondarydisplayplayer.mo 
	and secondarydisplayplayer.mo.valid 
	and ((secondarydisplayplayer.mo.skin == "sgimario") or (secondarydisplayplayer.mo.skin == "mario") or (secondarydisplayplayer.mo.skin == "luigi"))
	and (not secondarydisplayplayer.rk_dontusehealth))
		wahoo = true;
	end
	
	return wahoo;
end

local function doRecoveryHeart(mo)
    if (localMarioCheck() and mo.state ~= S_RKYRHRT)
		mo.state = S_RKYRHRT;
	elseif ((not localMarioCheck()) and mo.state ~= S_SPRRNG1 and (mo.state ~= S_INVISIBLE))
		if (mo.heartSpinSpeed <= 400)
			mo.state = S_SPRRNG1;
		end
	end
	
	if (mo.collideBuffer == 0)
        mo.heartPlayedSound = 0;

        if ((mo.heartSpinSpeed - 50) < 400)
            
            mo.heartSpinSpeed = 400;
            mo.heartTotalSpins = 0;
			mo.heartRingsSpawned = 0;
			if (mo.collidePlayer) then mo.collidePlayer = nil; end
        else
            mo.heartSpinSpeed = ($ - 50); -- FUCKING BLUA AARRRRGGHHHH
        end
    end
	
    if ((mo.heartTotalSpins + mo.heartSpinSpeed) >= FRACUNIT)

        local p = mo.collidePlayer;
        
		if (p and (p.mo.skin == "sgimario")) then 
			if (p.rkyrealHealth < 2176) then 
				S_StartSound(nil,sfx_64hrg,p);
				p.rkyrealHealth = ($ + 272);
				p.rkyHealth = p.rkyrealHealth;
			end 
		elseif (RK_HeartCheck(mo, p) and localMarioCheck())
			
			if ((p.mo.skin ~= "mario") and (p.mo.skin ~= "luigi"))
				// give rings
				p.rings = ($ + 10);
				S_StartSound(nil,sfx_itemup,p);
				mo.gotTenRings[mo.ringCheckIncrement] = p;
				mo.ringCheckIncrement = ($+1);
			elseif (p.mariohealth and (p.mariohealth < 3))
				S_StartSound(nil,sfx_64hrg,p);
				p.mariohealth = $ + 1;
			end
			
			
		end

        mo.heartTotalSpins = ($ - FRACUNIT);
    else
        mo.heartTotalSpins = ($ + mo.heartSpinSpeed);
    end
	
	
	if (mo.collideBuffer) then mo.collideBuffer = ($-1); end
    mo.angle = ($ + ((mo.heartSpinSpeed/182)*ANG1));
end

addHook("MobjThinker", function(mo)
    if (mo.heartSetup == nil)
        mo.heartPlayedSound = 0;
        mo.heartSpinSpeed = 400;
        mo.heartTotalSpins = 0;
		mo.heartRingsSpawned = 0; // only spawn 10
        mo.collideBuffer = 0;
		mo.collidePlayer = nil;
        mo.heartSetup = true;
    else
        doRecoveryHeart(mo)
    end
end, MT_RECOVERYHEART)



addHook("MobjCollide", function(tm, mo)
	if mo and mo.valid then
		if (mo.type ~= MT_RECOVERYHEART) then return end
		if ((tm) and (tm.player))
			local p = tm.player
			
			if (mo.collideBuffer == 0)
				if (tm.momz < 0)
					if (tm.z + tm.momz > mo.z + mo.height) then return end
				elseif (tm.z > mo.z + mo.height) 
					return 
				end

				if (tm.momz > 0)
					if (tm.z + tm.height + tm.momz < (mo.z)) then return end
				elseif (tm.z + tm.height < (mo.z))
					return
				end
				
				mo.heartSpinSpeed = ((200 * (p.speed/p.mo.scale)) + 1000);
				if (localMarioCheck())
					S_StartSound(mo, sfx_64hrt);
				elseif (RK_HeartCheck(mo, p))
					// give rings
					P_GivePlayerRings(p, 10)
					S_StartSound(nil,sfx_10rng,p);
					
					mo.gotTenRings[mo.ringCheckIncrement] = p;
					mo.ringCheckIncrement = ($+1);
					if (not localMarioCheck())
						mo.state = S_SPRRNG2;
					end
					
					mo.heartSpinSpeed = ((200 * (max(26*FRACUNIT, p.speed)/p.mo.scale)) + 1000);
				end
				mo.collideBuffer = 3;
				mo.collidePlayer = p;
			end
			mo.collideBuffer = 3;
			p = nil
		end
	end
	
	//fortnite beta archive
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	if (netgame or N64MarioPresent())
	and not (gametyperules & GTR_RINGSLINGER)
		local replaceHeart = P_SpawnMobj(mo.x, mo.y, mo.z, MT_RECOVERYHEART);
		P_RemoveMobj(mo);
	end
end, MT_RING_BOX)

// each heart has an array of non-mario players that have hit it and already gotten ten rings
// this prevevnts players from hogging the hearts to grind for rings/lives
addHook("MobjSpawn", function(mo)
	mo.gotTenRings = {};
	mo.ringCheckIncrement = 1;
end, MT_RECOVERYHEART)

local function getReferenceAngle(angle)
	local hundredthAng = 119305;
	local refang = 0;
	
	local intAng = angle/hundredthAng;
	local quad = 1;
	
	if (intAng < 0)
		intAng = ($ + 36000);
	end
	
	refang = (intAng % 9100);
	refang = (($ * FRACUNIT)/100);
	
	return FixedAngle(refang);
end

addHook("MobjThinker", function(mo)
	if (mo.colcheat)
		if (mo.colcheat == 1)
			
		end
		mo.colcheat = ($ - 1);
	end
end)

