-- P_Attract
-- ported from source
rawset(_G, "P_Attract", function(source, dest, nightsgrab, sm641up) -- Home in on your target
	local dist, ndist, speedmul;
	local vangle;
	local tx = dest.x;
	local ty = dest.y;
	local tz = dest.z + (dest.height/2); -- Aim for center
	local xydist = R_PointToDist2(tx, ty, source.x, source.y);

	if ((not dest) or (dest.health <= 0) or (not dest.player) or (not source.tracer))
		return;
    end

	-- change angle
	source.angle = R_PointToAngle2(source.x, source.y, tx, ty);

	// change slope
	dist = R_PointToDist2(0, tz, xydist, source.z);

	if (dist < 1)
		dist = 1;
    end
	
	source.tracerdist = dist;

	if (nightsgrab and source.movefactor)
		source.movefactor = ($ + FRACUNIT/2);
		
		if (sm641up)
			source.movefactor = min($, 20*FRACUNIT); -- not TOO fast, if we're a 1up
		end

		if (dist < source.movefactor)
			source.momx, source.momy, source.momz = 0, 0, 0;
			P_MoveOrigin(source, tx, ty, tz);
		else
			vangle = R_PointToAngle2(source.z, 0, tz, xydist);

			source.momx = FixedMul(sin(vangle), FixedMul(cos(source.angle), source.movefactor));
			source.momy = FixedMul(sin(vangle), FixedMul(sin(source.angle), source.movefactor));
			source.momz = FixedMul(cos(vangle), source.movefactor);
        end
	else
		if (nightsgrab)
			speedmul = P_AproxDistance(dest.momx, dest.momy) + FixedMul(8*FRACUNIT, source.scale);
		else
			speedmul = P_AproxDistance(dest.momx, dest.momy) + FixedMul(source.info.speed, source.scale);
        end

		source.momx = FixedMul(FixedDiv(tx - source.x, dist), speedmul);
		source.momy = FixedMul(FixedDiv(ty - source.y, dist), speedmul);
		source.momz = FixedMul(FixedDiv(tz - source.z, dist), speedmul);
	end

	-- Instead of just unsetting NOCLIP like an idiot, let's check the distance to our target.
	local nx = R_PointToDist2(tx, 0, source.x+source.momx, 0);
	local ny = R_PointToDist2(0, ty, nx, source.y+source.momy);
	ndist = R_PointToDist2(0, tz, ny, source.z+source.momz);
	
	if (ndist > dist) -- gone past our target
		-- place us on top of them then.
        source.momx, source.momy, source.momz = 0, 0, 0;
		P_MoveOrigin(source, tx, ty, tz);
    end
end)
